#include "variables.h"


int ReadCv(Cv)
arySp Cv;
{
int j;
double vapor;
vapor=0.0;
return;
}

void ReadMp(aryDpSpTp Mp)
{
 arySpTp 	*rawdMPtr;
 aryTp 		*rawDpPtr;
 double 	temp,UpBnd,LoBnd,rdMl,rdMl1,rDpl,rDpl1,UpdM,LodM,uDpi,lDpi;
 FILE 		*FilePtr;
 char 		line[maxLINE],junk[maxWORD];
 int 		i,j,k=-1,lines,MostDim=0,MostLines[SpDIM],DpFlag=0;
 word24 FileName;
strcpy(FileName,MASSfile);
strcat(FileName,INsuffix);
FilePtr=fopen(FileName,"r");
if (FilePtr==NULL) printf("MASSfile does not exist.\n");
else
{ 
  if (malloc(sizeof(arySpTp))==NULL)
   {printf("ReadMp malloc: insufficient memory for raw data."); exit(1);}
  rawDpPtr=(aryTp *)malloc(sizeof(aryTp));
  rawdMPtr=(arySpTp *)malloc(sizeof(arySpTp));
  for (lines=0;!feof(FilePtr);lines++)
  {
    for (j=0;j<SpDIM;) 
    {
      if (fscanf(FilePtr,"%lf",&temp)==1) {
	if ((j==0)&&(DpFlag==0)) {rawDpPtr[lines][k]=temp;DpFlag++;}	
        else {
          rawdMPtr[lines][j][k]=temp;
          if (j==0) DpFlag--; 
          j++; }}
      else  {
        lines--; 
        j=SpDIM;  }
    }
    if (lines >= MostLines[k]) {
      MostLines[k]=lines;
      if (MostLines[k]>=MostDim) {
        MostDim=MostLines[k];
        rawDpPtr=realloc(rawDpPtr,(MostDim+2)*sizeof(aryTp));
        rawdMPtr=realloc(rawdMPtr,(MostDim+2)*sizeof(arySpTp)); }}
    fgets(line,sizeof(line),FilePtr);
    if (!(strstr(line,keyTYPE) == NULL)) 
     {sscanf(line,"%s %d",junk,&k); lines=-1;MostLines[k]=0;}      
} }
fclose(FilePtr);

if (!(j==SpDIM)|!(++k==TpDIM)) 
 {printf("Wrong number of types/species in MASSfile."); exit(1);}
for (k=0;k<TpDIM;k++) {
 for (j=0;j<SpDIM;j++) { 
  for (i=0;i<DpDIM;i++) {
   Mp[i][j][k]=0;
   for (lines=0; lines<MostLines[k];lines++){
    uDpi=LOG(dryDp(i+0.5));		lDpi=LOG(dryDp(i-0.5));
    rdMl=rawdMPtr[lines][j][k];		rdMl1=rawdMPtr[lines+1][j][k];
    rDpl=LOG(rawDpPtr[lines][k]);	rDpl1=LOG(rawDpPtr[lines+1][k]);
    UpBnd=min(uDpi,rDpl1);		LoBnd=max(lDpi,rDpl);
    UpdM=rdMl1+((UpBnd-rDpl1)/(rDpl1-rDpl))*(rdMl1-rdMl);
    LodM=rdMl+((LoBnd-rDpl)/(rDpl1-rDpl))*(rdMl1-rdMl);
    if ( (rDpl1>lDpi) && (rDpl<uDpi) )     
     Mp[i][j][k]+=0.5*(LodM+UpdM)*(UpBnd-LoBnd);}
   printf("ReadMp i%dj%dk%d %e\n",i,j,k,Mp[i][j][k]);
 }}}
free(rawDpPtr);
free(rawdMPtr);
return;
}

void ReadSaltNp(aryDp SaltNp)
/* Size distribution of sea spray taken from data of Bowyer et al. 1990
Fig. 7 Curve "15-20" */
{
 double	 	*rawdNPtr,*rawDpPtr;
 double 	temp1=0,temp2,UpBnd,LoBnd,rdNl,rdNl1,rDpl,rDpl1,UpdN,LodN;
 double 	TotalSaltNp=0,uDpi,lDpi;
 FILE 		*FilePtr;
 char 		line[maxLINE],junk[maxWORD];
 int 		i,lines,MostLines=0,DpFlag=0;
FilePtr=fopen(SALTfile,"r");
if (FilePtr==NULL) {printf("SALTfile does not exist.\n"); exit(1);}
if (malloc(sizeof(arySpTp))==NULL)
   {printf("ReadMp malloc: insufficient memory for raw data."); exit(1);}
rawDpPtr=(double *)malloc(sizeof(double));
rawdNPtr=(double *)malloc(sizeof(double));
for (lines=0;!feof(FilePtr);lines++)  {
  fscanf(FilePtr,"%lf %lf ",&temp1,&temp2) ;
    rawDpPtr[lines]=temp1  /* determine dry diameter from mass fraction NaCl */
     *pow((naclFRAC*(SeaSaltDensity()/SpDensity(naclSP))),(1./3.));
    rawdNPtr[lines]=temp2;       
printf("SaltInit i%i Dp%e SaltNp%e %e\n",lines,temp1,temp2,temp2);
  if (temp1<=0)    {   lines--;}      
  if (lines >= MostLines) {
    MostLines=lines;
    rawDpPtr=realloc(rawDpPtr,(MostLines+2)*sizeof(double));
    rawdNPtr=realloc(rawdNPtr,(MostLines+2)*sizeof(double)); }
  fgets(line,sizeof(line),FilePtr);  }
fclose(FilePtr);
for (i=0;i<DpDIM;i++) {
  SaltNp[i]=0;
  uDpi=LOG(dryDp(i+0.5));		lDpi=LOG(dryDp(i-0.5));
  for (lines=0; lines<MostLines;lines++){
    rdNl=rawdNPtr[lines];		rdNl1=rawdNPtr[lines+1];
    rDpl=LOG(rawDpPtr[lines]);	rDpl1=LOG(rawDpPtr[lines+1]);
    if (lines==(MostLines-1)) {rdNl1=0; rDpl1=rDpl*1.2;}
    UpBnd=min(uDpi,rDpl1);		LoBnd=max(lDpi,rDpl);
    UpdN=rdNl1+((UpBnd-rDpl1)/(rDpl1-rDpl))*(rdNl1-rdNl);
    LodN=rdNl+((LoBnd-rDpl)/(rDpl1-rDpl))*(rdNl1-rdNl);
    if ( (rDpl1>lDpi) && (rDpl<uDpi) )     
     SaltNp[i]+=0.5*(LodN+UpdN)*(UpBnd-LoBnd);}
  TotalSaltNp+=SaltNp[i];}
for (i=0;i<DpDIM;i++) {
  SaltNp[i]/=TotalSaltNp;
printf("SaltInit i%i Dp%e SaltNp%e %e\n",i,dryDp(i),SaltNp[i],TotalSaltNp);}
free(rawDpPtr);
free(rawdNPtr);
return;
}

void CalcNp(aryDpTp Np,aryDpSpTp Mp)
{
 int i,k;
for (i=0;i<DpDIM;i++) { 
  for (k=0;k<TpDIM;k++) {  
    Np[i][k]=drySMass(i,k,Mp)/dryPMass(i,k,Mp);
    printf("CalcNp i%d k%d %f\n",i,k,Np[i][k]);}}
return;
}

struct dataProf *ReadMet(int *MetIndexPtr)
{
 struct dataProf *MetPtr; 
 FILE *FilePtr;
 char line[maxLINE];
 int lines =0,MostLines=0;
 double temp1=0,temp2,temp3,temp4;
 word24 FileName;
strcpy(FileName,METfile);
strcat(FileName,INsuffix);
FilePtr=fopen(FileName,"r");
if (FilePtr==NULL) printf("METfile does not exist");
else
{
  if (malloc(sizeof(struct dataProf))==NULL) 
   {printf("ReadMet malloc: insufficient memory for Met data."); exit(1);}
  MetPtr=(struct dataProf *)malloc(sizeof(struct dataProf));
  for (lines=0;!feof(FilePtr);lines++) {
    fscanf(FilePtr,"%lf %lf %lf %lf",&temp1,&temp2,&temp3,&temp4) ;
	MetPtr[lines].alt=temp1;
        MetPtr[lines].temp=temp2+ZEROC;/*convert degC to K*/
        MetPtr[lines].pres=temp3;/*mb*/
   	MetPtr[lines].dewt=temp4+ZEROC;/*convert degC to K*/  
    if (temp1<=0)    {   lines--;}   
    if (lines >= MostLines) {
      MostLines=lines;
      MetPtr=realloc(MetPtr,(MostLines+2)*sizeof(struct dataProf));}
    fgets(line,sizeof(line),FilePtr);}
  fclose(FilePtr);
}
*MetIndexPtr=lines ;
return MetPtr;
}

struct dataInit *ReadInit(int *InitIndexPtr)
{
 struct dataInit *InitPtr; 
 FILE *FilePtr;
 char line[maxLINE];
 int lines =0,MostLines=0,ind;
 double temp1=0,temp2=0,temp3=0,temp4=0,temp5=0,temp6=0,temp7=0;
 word24 FileName;
strcpy(FileName,INITfile);
strcat(FileName,INsuffix);
FilePtr=fopen(FileName,"r");
if (FilePtr==NULL) printf("INITfile does not exist");
else
{
  if (malloc(sizeof(struct dataInit))==NULL) 
   {printf("ReadInit malloc: insufficient memory for Init data."); exit(1);}
  InitPtr=(struct dataInit *)malloc(sizeof(struct dataInit));
  for (lines=0;!feof(FilePtr);lines++)
  {
    fscanf(FilePtr,"%d %lf %lf %lf %lf %lf %lf %lf",&ind,&temp1,&temp2, 
     &temp3,&temp4,&temp5,&temp6,&temp7);
	InitPtr[lines].index=ind;  	InitPtr[lines].wind=temp1;       
        InitPtr[lines].updraft=temp2;	InitPtr[lines].height=temp3; 
	InitPtr[lines].base=temp4; 	InitPtr[lines].maxlwc=temp5/CCperM3;
	InitPtr[lines].so2=temp6;	InitPtr[lines].ohestd=temp7;/*ppb*/
    if (temp3<=0)    {   lines--; printf("lines--");}   
    if (lines >= MostLines) {
      MostLines=lines;
      InitPtr=realloc(InitPtr,(MostLines+2)*sizeof(struct dataInit));}
    fgets(line,sizeof(line),FilePtr);
printf("READInit %d %d %lf %lf %lf %lf %lf %lf %lf\n",lines,ind,temp1,temp2,temp3,temp4,temp5,temp6,temp7);}
  fclose(FilePtr);
}
*InitIndexPtr=lines ;
return InitPtr;
}